<?php

namespace OzzModz\WhoReadThread\XF\Pub\Controller;

use XF\Mvc\ParameterBag;

class Thread extends XFCP_Thread
{
	public function actionIndex(ParameterBag $params)
	{
		$parent = parent::actionIndex($params);

		if ($parent instanceof \XF\Mvc\Reply\View && \XF::visitor()->hasPermission('view', 'ozzmodzWRTview'))
		{
			/** @var \XF\Entity\Thread $thread */
			$thread = $parent->getParam('thread');
			if (!$thread)
			{
				return $parent;
			}

			$forums = $this->options()->ozzmodz_wrt_forums;
			if (in_array($thread->node_id, $forums))
			{
				/** @var \OzzModz\WhoReadThread\XF\Repository\Thread $threadRepo */
				$threadRepo = $this->getThreadRepo();
				$usersReadFinder = $threadRepo->findUsersRead($thread->thread_id);
				$usersRead = $usersReadFinder->fetch();
				$parent->setParams([
					'totalUsers' => $usersRead->count(),
					'usersReader' => $usersRead
				]);
			}
		}

		return $parent;
	}

	public function actionWhoRead(ParameterBag $params)
	{
		$thread = $this->assertViewableThread($params->thread_id);

		$forums = $this->options()->ozzmodz_wrt_forums;
		if (!in_array($thread->node_id, $forums) && !\XF::visitor()->hasPermission('view', 'ozzmodzWRTview'))
		{
			return $this->noPermission();
		}

		/** @var \OzzModz\WhoReadThread\XF\Repository\Thread $threadRepo */
		$threadRepo = $this->getThreadRepo();
		$usersReadFinder = $threadRepo->findUsersRead($thread->thread_id);
		$usersRead = $usersReadFinder->fetch();

		$viewParams = [
			'thread' => $thread,
			'totalUsers' => $usersRead->count(),
			'readUsers' => $usersRead
		];

		return $this->view('XF:Thread\WhoRead', 'ozzmodz_wrt_overlay', $viewParams);
	}
}