<?php

namespace OzzModz\WhoReadThread\XF\Repository;

class Thread extends XFCP_Thread
{
	public function findUsersRead($threadId)
	{
		return $this->finder('XF:ThreadRead')
			->with('User')
			->where('thread_id', $threadId)
			->order('thread_read_date', 'DESC');
	}

	public function pruneThreadReadLogs($cutOff = null)
	{
		if ($cutOff === null)
		{
			$readDataLifetime = $this->options()->ozzmodz_wrt_readDataLifetime;
			if ($readDataLifetime <> 0)
			{
				if ($readDataLifetime <= -1)
				{
					return;
				}
				else
				{
					$cutOff = \XF::$time - $this->options()->ozzmodz_wrt_readDataLifetime * 86400;
				}
			}
		}

		parent::pruneThreadReadLogs($cutOff);
	}
}